[![Github Actions CI](https://github.com/dint-dev/dent/workflows/Dart%20CI/badge.svg)](https://github.com/dint-dev/dent/actions?query=workflow%3A%22Dart+CI%22)

# Overview
Dent aims to give data layer for Dart developers writing ecommerce or other applications. Dent is
used by [Dint](https://github.com/dint-dev/dint).

The classes are:
  * __Immutable__. They use [built_value](https://pub.dev/packages/built_value).
  * __Serializable__. The classes use [built_value](https://pub.dev/packages/built_value) serialization.
  * __Database friendly__. We have an integration with the package
    [datastore](https://pub.dev/packages/datastore). Mapping to a relational database model would be
    simple too.

The goal is that this package will help developers to:
  * __Save time__. All you need to do is to connect to some database supported by the package
    [datastore](https://pub.dev/packages/datastore).
  * __Reduce defects__. A data layer audited by more teams than just your own is likely to contain
    less defects when it comes to database modeling, programming, security, or regulatory
    compliance.
  * __Interoperability__. You can take advantage of possible future open-source/commercial
    packages that are compatible with the data layer.


## Examples
### Identity
  * Account
  * Organization
  * Person
  * PersonName

### Business
  * Product
  * ShoppingCart
  * ShoppingCartItem
  * ShoppingTransaction

### World
  * Place

## Contributing
If you are doing major changes, it might be a good idea to first create an issue
[in the issue tracker](https://github.com/dint-dev/dent/issues) and explain your plan. If you just
fix something or add a small relevant feature, just go ahead!

This is how you contribute:
  1. Fork [github.com/dint-dev/dent](https://github.com/dint-dev/dent) by pressing fork button.
  2. Clone your fork to your computer: `git clone github.com/your_username/dent`
  3. Do your changes. When you are done, commit changes with `git add -A` and `git commit`.
  4. Push changes to your personal repository: `git push origin`
  5. Go to [github.com/dint-dev/dent](https://github.com/dint-dev/dent) and create a pull request.

Contributors may be added to the Github organization team so they can save time by pushing
directly to the repository.